###---------------------------------------------------------------------
#	  Name: PurgeAll.rb
#   Description: Plugins > Purge...
#   Author: TIG (c) 20070225
#   Usage: Pick "Purge...", or use a Shortcut Key to it.
#           It Purges all UNUSED Components, Layers, Materials, Styles.
#           Choose which type(s) to purge from the dialog (Yes/No).
#           It only works in v6+.
#		Type: Tool
#   Version: 1.0	 2070225	First issue.
#            1.1   20070225 v.6000277 alowed !
#            1.2   20070226 A 4 options dialog added, now Menu= Purge...
#            1.3   20070226 'Make Report' option added.
#            1.4   20070304 Glitch on 'default' options fixed [?].
###---------------------------------------------------------------------
require 'sketchup.rb'
###---------------------------------------------------------------------
class PurgeAll ### v1.3
def PurgeAll::do
  ### show VCB and status info
  Sketchup::set_status_text(("Purger..." ),SB_PROMPT)
  Sketchup::set_status_text("",SB_VCB_LABEL)
  Sketchup::set_status_text("",SB_VCB_VALUE)
  ###
  if Sketchup.version_number < 6000277###v1.1
    Sketchup::set_status_text(("Purger... Erreur..." ),SB_PROMPT)
    UI.beep
    UI.messagebox("Desole, mais'Purger...'\nne fonctionne qu'avec la version 6 ou ulterieur. ")
    return nil
  end#if
  ### dialog ###v1.2
  @compos="Oui" if not @compos
  @layers="Oui" if not @layers
  @maters="Oui" if not @maters
  @styles="Oui" if not @styles
  @report="Oui" if not @report
  prompts=["Purger Composants: ","Purger Calques: ","Purger Materiaux","Purger Styles: ","Creer Rapport: "]
  values=[@compos,@layers,@maters,@styles,@report]
  yn="Oui|Non"###v1.4
  popups=[yn,yn,yn,yn,yn]
  title="Purger - Options"
  results=inputbox(prompts,values,popups,title)
  return nil if not results
### do processing of results
  @compos=results[0]
  @layers=results[1]
  @maters=results[2]
  @styles=results[3]
  @report=results[4]
  ### ###v1.2
  model=Sketchup.active_model
  entities=model.entities
  definitions=model.definitions
  layers=model.layers
  materials=model.materials
  styles=model.styles
  model.start_operation "Purger..."
  ###
  if @compos=="Oui" ###v1.2
    compos1=definitions.count
    definitions.purge_unused
    co=compos1-definitions.count
    cmsg="\nComposants:\t "+co.to_s
  else
    cmsg="\n..."
  end#if
  if @layers=="Oui" ###v1.2
    layers1=layers.count
    layers.purge_unused
    la=layers1-layers.count
    lmsg="\nCalques:\t\t "+la.to_s
  else
    lmsg="\n..."
  end#if
  if @maters=="Oui" ###v1.2
    materials1=materials.count
    materials.purge_unused
    ma=materials1-materials.count
    mmsg="\nMateriaux:\t\t "+ma.to_s
  else
    mmsg="\n..."
  end#if
  if @styles=="Oui" ###v1.2
    styles1=styles.count
    styles.purge_unused
    st=styles1-styles.count
    smsg="\nStyles:\t\t "+st.to_s+"\n"
  else
    smsg="\n...\n"
  end#if
  ### report v1.3
  if @compos=="Non" && @layers=="Non"
    if @maters=="Non" && @styles=="Non"
      UI.messagebox("Rien a purger !\t")
      return nil
    end#if
  end#if
  if @report=="Oui"
    UI.messagebox("Purges:\n"+cmsg+lmsg+mmsg+smsg+"\t\t\t")
  end#if
  ###
  model.commit_operation###for undo
end #def
end #class
###
### menu bits
if(not file_loaded?("fr_PurgeAll.rb"))
  UI.menu("Plugins").add_item("Purger...") {PurgeAll.do}
end
file_loaded("fr_PurgeAll.rb")
###
